Quantcast
Channel: Rhino Developer - McNeel Forum
Viewing all 8546 articles
Browse latest View live

Iterate on all commands

$
0
0

@kitjmv wrote:

Hello!
I search how iterate on all commands loaded in Rhino with C#.
I’m sorry, the doc API end google don’t give me a response.

Posts: 5

Participants: 2

Read full topic


Access Edge Smoothing Settings from Api

$
0
0

@ParanoidAndroid wrote:

Hi, is there a way to access the edge smoothing settings of a Rhino object via the API?
I.e. “is edge smoothing activated and if yes what are the parameters”?
Alternatively, is there a way to get the “smoothed” meshes from such an object instead of the regular renderer meshes?

Posts: 6

Participants: 2

Read full topic

Subclassing from CRhinoMeshObject and overriding wireframe curves

$
0
0

@gccdragoonkain wrote:

I’ve subclassed CRhinoMeshObject and have it working on a basic (it displays correctly). But I want to completely override the wireframe for the object, so I can provide my own curves during display instead of the dense mesh wireframe.

How can I do this? I overrided GetWireframeCurves() but it is never called. I can land in Draw() but I have no idea what to put in there. I want it to render the same as it does now, but with my own custom wireframe curves.

Posts: 1

Participants: 1

Read full topic

Enabling Empty Custom Conduit Causes Lags in V6

$
0
0

@D-W wrote:

I noticed that viewport with empty but enabled custom conduit causes lags in v6 in v5 it doesn’t matter - interesting is that if i only put one box in conduit everything works smooth but unless conduit is enabled and empty i have rather slideshow in vp.

Not sure who should look at this @nathanletwory ?

Posts: 3

Participants: 2

Read full topic

Need help to select id with python

$
0
0

@i.a wrote:

Hi all of you genious out there .

I’ve this script that I need to improve a bit.

! _-RunPythonScript (

import rhinoscriptsyntax as rs

curve = rs.GetObject(“Select a curve”)

if rs.IsCurve(curve):

print "Curve dimension =", rs.CurveLength(curve)

l = rs.CurveLength (curve )

start = ( 0, 0, 0 )
end = ( l, 0, 0 )

base= rs.AddLine(start, end)

turns =rs.GetReal(“n of turns”)
point0 = (0,0,0)
point1 = (l,0,0)
pitch = l/turns
radius0 =rs.GetReal(“spiral radius”)

spiral01= rs.AddSpiral(point0, point1,pitch, turns, radius0, )
spiral02 = rs.RotateObject((spiral01), (0,0,0), 180, (1,0,0), copy=True)

cmd1 = ( 'Scorri ( copy = False) Selid ’ + str( spiral01 )+
’ Invio Selid ’ + str( base ) + ’ Selid ’ + str( curve ) )
rs.Command( cmd1 )

cmd2 = ( 'Scorri ( copy = False) Selid ’ + str( spiral02 )+
’ Invio Selid ’ + str( base ) + ’ Selid ’ + str( curve ) )
rs.Command( cmd2 )

cmd3 = ( 'Selid ’ +str(spiral01))
rs.Command(cmd3)

cmd4 = ( 'Selid ’ +str(spiral02))
rs.Command(cmd4)

cmd5 = ( 'Selid ’ +str(base))
rs.Command(cmd5)

rs.Command(’_delete’)

cmd6 = ( ‘Selid ’ +str(curve))
rs.Command(cmd6)
rs.Command(’_hide’)

crv1 = rs.GetObject(“sel crv1”)
crv2 = rs.GetObject(“sel crv2”)

radiusp= rs.GetReal( “raggio pipe” )
rs.AddPipe(crv1,0,radiusp)
rs.AddPipe(crv2,0,radiusp)
)

So basically what it does is to create a rope kind once a curve is selected .

You pick the curve it will make a line of the same lenght and wrap it with a spiral. Then flow the spiral using the line as base crv and the input curve as target crv.

last it will prompt to select the two new spiral that are been created around the original curve and ask for a radius to pipe them.

My question is how do I get the ID of those two new spiral so that it’s no more necessary to select them manually ? … I’ve tryied many ways with no result .

Any idea ?
Any help?

thanks a lot,
alberto

Posts: 4

Participants: 2

Read full topic

Unable to use ImageSharp package in a plugin on Mac

ExtendCrvOnSrf in Python

$
0
0

@fluxguys wrote:

Is there any particular reason why the ExtendCrvOnSrf functionality isn’t included in rhinoscript? Is there a recommended way of extending a curve on a surface using Python? Thanks!

Posts: 2

Participants: 2

Read full topic

Variable offset of a curve

$
0
0

@direyes_11 wrote:

Hello,

Anyone knows if there is an option to develop a script that works similarity to command variableoffsetsrf but for curves. I need to create new paint patterns for a project but the patterns change according to position. It takes the same geometry of the first one but with the variable offset. Attached a picture that shows a test pattern.

Posts: 1

Participants: 1

Read full topic


Is there any way to create a .3dm file viewer in Winform or Wpf without Rhino?

Python rhinoscript AddText() not working

$
0
0

@danielogg92 wrote:

Hi

Does anyone know whether there is a work around for this method not working. We I call this method I get this error message

Runtime error (NotSupportedException) This type of object is not supported in Grasshopper, so this python script cannot create it.


Thanks

Posts: 1

Participants: 1

Read full topic

Mesh faces at XX angles as a percentage of total mesh faces?

$
0
0

@ChristopherBotha wrote:

I am trying to work out how to analyze a mesh to determine what percentage of the mesh contains faces at more than XX angle to the adjacent mesh face?

Example Mesh A = 1000 poly’s, 200polys are at more than 80 degree angle to adjacent polys

Assuming it counted both faces the actual percentage of polys at more than 80 degrees in this case is 10%

Completely lost on how to do this in rhinocommon (c#)

Dupmeshedge in rhino for example must calculate this to be able to determine an “edge” as being defined as more than XX angle?

Any pointers welcome please!

Posts: 1

Participants: 1

Read full topic

Issue with RunScript in Rhino6

$
0
0

@Alexandre_Beaudet wrote:

Hello,

I’m having an issue with my plugin.
It was working in Rhino 5 but not anymmore.

I needed to get the list of LayerStates that are saved so I used the command _-LayerStateManager to export them to a temporary file ; then read that file to generate a list of LayerState in my program.

Calling _-LayerStateManager Export <some_path> _Enter works fine when using the command panel in Rhinoceros, but it doesn’t do anything (anymore) when called from my plugin.
The method Rhino.RhinoApp.RunScript returns false all the time, and my temporary file remains empty …

Am I missing something ?
Have things changed since Rhino 5 regarding script execution ?

Thanks,
Alexandre

Posts: 1

Participants: 1

Read full topic

Problem adding new mesh to document

$
0
0

@clement wrote:

Hi @dale,

i am building a Rhino.Geometry.Mesh from another mesh by copying it and then chaning the vertex locations. After this is done, i update the vertex normals and facenormals. While doing this, i ran in a situation where some meshes cannot be added to the document in V5 and V6 using:

guid = scriptcontext.doc.Objects.AddMesh(new_mesh)

which results in an empty guid. If i query new_mesh.IsValid before i try to add the mesh to the document, i get False. Is there a way to find out what is not valid with the new mesh ? (It is manifold, compacted etc)

_
c.

Posts: 9

Participants: 3

Read full topic

Error message: This object cannot be modified because it is controlled by a document

$
0
0

@Goswin wrote:

I create a NURBSCurve via code. when cloning it i get this Error.
I thought only Rhino Objects can belong to a document not Geometery classes?
What could be the problem here?
(I am not doing this on the GUI Thread.)

Rhino.Runtime.DocumentCollectedException: This object cannot be modified because it is controlled by a document.
   at Rhino.Runtime.CommonObject.ConstPointer()
   at Rhino.Geometry.Curve.Duplicate()
   at ....

Posts: 7

Participants: 3

Read full topic

Problem with Eto CustomCell

$
0
0

@Alexandre_Beaudet wrote:

Hi,

I’m trying to use the TreeGridView of Eto with custom cells.
Documentation is scarce regarding this Eto class so I’m asking here …

Here’s the code. I’m just trying to make a cell that displays a Label for now :

CustomCell treecell = new CustomCell {
	CreateCell = (args) => {
		Label label = new Label{ Text = "hello" };
		return label;
	},
	ConfigureCell = (args, control) => {
		Label label = control as Label;
		label.DataContext = args.Item;
	}
};

TreeGridView view = new TreeGridView {
	DataStore = collection,
	ShowHeader = false,
	AllowColumnReordering = false
};
view.Columns.Add(new GridColumn { HeaderText = "hello", Visible = true, DataCell = treecell });

As seen in the following picture, the ‘tree’ behavior is there (nodes can be expanded and such …), though the label is not appearing :

Sans%20titre

Has anyone used a TreeGridView ?
With custom cells ?
Is the version of Eto bundled with Rhino up to date ?

I’ve seen this post in the Rhino forums where the user tells that the CustomCell feature didn’t work on Mac at the time. Is this related ? (I’m on Windows though)

Thank you for your time
Alexandre

Posts: 3

Participants: 3

Read full topic


Migration guide for c# plugins..?

RebuildTrimsForV2 modifies Trim geometry

$
0
0

@swg1975 wrote:

Hi!
After running the following code the trimming loops of the face are slightly modified. Why?

new_brep = brep.DuplicateBrep() # make a duplicate
face = new_brep.Faces[0] # select a BrepFace
surface = face.UnderlyingSurface().ToNurbsSurface() # get the surface geometry as nurbs
new_brep.RebuildTrimsForV2(face, surface) # rebuild trims for nurbs
face.ChangeSurface(new_brep.AddSurface(surface)) # replace the surface geometry
face.RebuildEdges(1e-5, True, True) # edges are changing! Why?

Posts: 1

Participants: 1

Read full topic

Hidden Viewport for Screen Capture

$
0
0

@jason_stevenson wrote:

Is there a way to have a hidden viewport, so that I can use it to capture images in a specific way, without letting the user see it is happening?

Thanks!

Jake

Posts: 3

Participants: 2

Read full topic

How to run RVB code in vb.net development environment

VB.NET write add form interface

Viewing all 8546 articles
Browse latest View live